IFNDEF _MSAgent_
_MSAgent_ equ 1

include Agtsvr.inc       ; MS AGENT COM HEADERS...
; --=====================================================================================--
; #CLASS:    MSAgent 
; #VERSION:  1.0
; --=====================================================================================--
; Built by NaN's Object Class Creator
;  Sept 19, 2001
;
; By NaN ( jaymeson@hotmail.com )
; http://nan32asm.cjb.net
;
; --=====================================================================================--
; #AUTHOR: NaN 
; #DATE:   Sept 24, 2001
;
; #DESCRIPTION:
;
;          This Object creates an Ms Agent COM object.  Used for 'speaking' whatever
;          text you send to an instance object of this class<br><br>This this class uses
;          COM's and you need to have the following incldudes from Ernie's COM model
;          to properly complile this class:
;<pre><h6>
;    include \masm32\include\ole32.inc            ; Interfacing COM
;    include \masm32\com\include\oaidl.inc        ; Used for Coinvoke and others
;    include \masm32\include\oleaut32.inc         ; Used for SysAllocString and Varient
;    include \masm32\include\bstrlib.inc          ; BSTR functions
;    include \masm32\include\L.inc                ; BSTR functions
;
;    includelib \masm32\lib\ole32.lib             ; Interfacing COM 
;    includelib \masm32\lib\oleaut32.lib          ; COM tools lib    
;    includelib \masm32\lib\bstrlib.lib           ; The BSTR lib
;</h6></pre>
;
;  <b>NOTE</b>: This is text->speech output only, I am still figuring out the Mouse Input
;   Events for this.  Future Versions of this class will suport pop-up boxes over the agent
;   character and send WM_COMMAND messages to your client window..
; --=====================================================================================--
; CLASS METHOD PROTOS
; --=====================================================================================--
   MSAgent_Init    PROTO  :DWORD

; --=====================================================================================--
; FUNCTION POINTER PROTOS
; --=====================================================================================--
   MSAg_destructorPto    TYPEDEF  PROTO  :DWORD 
   MSAg_getAgentPto    TYPEDEF  PROTO  :DWORD
   MSAg_HidePto    TYPEDEF  PROTO  :DWORD
   MSAg_ShowPto    TYPEDEF  PROTO  :DWORD
   MSAg_GesturePto    TYPEDEF  PROTO  :DWORD, :DWORD
   MSAg_SpeakPto    TYPEDEF  PROTO  :DWORD, :DWORD
   MSAg_ReadClipboardPto    TYPEDEF  PROTO  :DWORD, :DWORD

; --=====================================================================================--
; CLASS STRUCTURE
; --=====================================================================================--
   CLASS MSAgent, MSAg
      CMETHOD destructor
      CMETHOD getAgent
      CMETHOD Hide
      CMETHOD Show
      CMETHOD Speak
      CMETHOD Gesture
      CMETHOD ReadClipboard
      hAgentObject     dd    ?
      hAgentChar       dd    ?
      hBuf             dd    ?
   MSAgent ENDS

.data

   BEGIN_INIT 
      dd offset MSAg_destructor_Funct
      dd offset MSAg_getAgent_Funct
      dd offset MSAg_Hide_Funct
      dd offset MSAg_Show_Funct
      dd offset MSAg_Speak_Funct
      dd offset MSAg_Gesture_Funct
      dd offset MSAg_ReadClipboard_Funct
      dd NULL
      dd NULL
      dd NULL
   END_INIT

     ; MS Agent Com stuff...
     CLSID_AgentServer   GUID      sCLSID_AgentServer
     IID_IAgentEx        GUID      sIID_IAgentEx
     IID_IAgent          GUID      sIID_IAgent
     IID_IAgentBalloon   GUID      sIID_IAgentBalloon
     IID_IAgentCommands  GUID      sIID_IAgentCommands
     

     MSAg_szGestureUp       WCHAR     L(<GestureUp\0>)
     MSAg_szGestureDown     WCHAR     L(<GestureDown\0>)
     MSAg_szGestureLeft     WCHAR     L(<GestureLeft\0>)
     MSAg_szGestureRight    WCHAR     L(<GestureRight\0>)
     MSAg_szGestureRest     WCHAR     L(<Restpose\0>)
     MSAg_szGestureGreet    WCHAR     L(<Greet\0>)
     MSAg_szGestureSurprised WCHAR    L(<surprised\0>)


     AGENT_POS_LEFT      equ 3
     AGENT_POS_RIGHT     equ 4
     AGENT_POS_UP        equ 1
     AGENT_POS_DOWN      equ 2
     AGENT_POS_REST      equ 0
     AGENT_POS_GREET     equ 5
     AGENT_POS_SURPRISED equ 6
     
.data?
     vPath          VARIANT     <?>

.code
; --=====================================================================================--
; #METHOD:      CONSTRUCTOR (NONE)
;
; #DESCRIPTION: Creates an Agent Instance.  It uses the Default Character (Genie) on
;               your system.  Future versions will suport other characters.  When created
;               the character is NOT shown.  You have to instruct it to be shown before
;               sending any text to speak..
;
;
; #RETURN:      Handle to MSAgent Object (not COM, but MASM32 OOP object)..
; --=====================================================================================--
MSAgent_Init  PROC uses edi esi lpTHIS:DWORD
   LOCAL     IReqID         :DWORD
   LOCAL     IChrID         :DWORD

   SET_CLASS MSAgent
   SetObject edi, MSAgent

     invoke CoInitialize, NULL
     invoke CoCreateInstance, ADDR CLSID_AgentServer, NULL, CLSCTX_SERVER,\
                              addr IID_IAgentEx, addr [edi].hAgentObject
     .IF_SUCCEEDED

        ; Load the Agent Server
        invoke VariantInit, addr vPath
        mov vPath.vt, VT_EMPTY
        coinvoke [edi].hAgentObject, IAgentEx, Load, vPath, addr IChrID, addr IReqID
        .IF_SUCCEEDED
           ; Get the Agent Character
           coinvoke [edi].hAgentObject, IAgentEx, GetCharacter, IChrID, addr [edi].hAgentChar
     
           .IF_SUCCEEDED
               ;LOW BYTE MAJOR LANGUAGE, HIGH BYTE SUB LANGUAGE
      	     coinvoke [edi].hAgentChar, IAgentCharacterEx, SetLanguageID, 0409H ; Canadian English
           .ENDIF
           
           .IF_SUCCEEDED
               ; Make a gmem buffer..
               invoke GlobalAlloc, GMEM_MOVEABLE OR GMEM_DDESHARE, 4096
               mov [edi].hBuf, eax
           .ENDIF
           
        .ENDIF
        
     .ENDIF


   ReleaseObject edi
   ret
MSAgent_Init ENDP

; --=====================================================================================--
; #METHOD:      destructor 
;
; #DESCRIPTION: Destroys the COM instance.  As well as the Global memory allocated with
;               this instance (used for BSTRING conversions)..
;
; #RETURN:      Nothing..
; --=====================================================================================--
MSAg_destructor_Funct  PROC uses edi lpTHIS:DWORD 
   LOCAL  ICharID         :DWORD
   
   SetObject edi, MSAgent
     
     METHOD edi, MSAgent, Hide
     
     .if([edi].hAgentObject)        
        coinvoke [edi].hAgentObject, IAgentEx, Unload, addr ICharID
        invoke CoUninitialize
        
        invoke VariantClear, addr vPath
     .endif
     
     .if([edi].hBuf)
        invoke GlobalFree, [edi].hBuf
     .endif
 
   ReleaseObject edi
   ret
MSAg_destructor_Funct  ENDP

; --=====================================================================================--
; #METHOD:      getAgent (NONE)
;
; #DESCRIPTION: Returns the pIAgentCharacter COM pointer..
;
; #RETURN:      pIAgentCharacter (COM)..
; --=====================================================================================--
MSAg_getAgent_Funct  PROC uses edi lpTHIS:DWORD
   SetObject edi, MSAgent

   mov eax, [edi].hAgentChar

   ReleaseObject edi
   ret
MSAg_getAgent_Funct  ENDP

; --=====================================================================================--
; #METHOD:      Hide ()
;
; #DESCRIPTION: Hides the Character, doing its Hide animation..
;
; #RETURN:      Nothing..
; --=====================================================================================--
MSAg_Hide_Funct  PROC uses edi lpTHIS:DWORD
   LOCAL  IReqID  :DWORD
   SetObject edi, MSAgent
     
     .if( [edi].hAgentChar )
       coinvoke [edi].hAgentChar, IAgentCharacterEx, Hide, FALSE, addr IReqID
     .endif

   ReleaseObject edi
   ret
MSAg_Hide_Funct  ENDP

; --=====================================================================================--
; #METHOD:      Show ()
;
; #DESCRIPTION: Shows the Agent Character, doing its show animation..
;
; #RETURN:      Nothing..
; --=====================================================================================--
MSAg_Show_Funct  PROC uses edi lpTHIS:DWORD
   LOCAL  IReqID  :DWORD
   SetObject edi, MSAgent
     
     .if( [edi].hAgentChar )
       coinvoke [edi].hAgentChar, IAgentCharacterEx, Show, FALSE, addr IReqID
     .endif
     
   ReleaseObject edi
   ret
MSAg_Show_Funct  ENDP

; --=====================================================================================--
; #METHOD:      Gesture(GCODE)
;
; #DESCRIPTION: MultiLine Description.  <b>HTML TAGS ALLOWED</b>.
;               End with double period..
;
; #PARAM:       GCODE      This is the Gesture type.  There currently is the following
;                          gestures animations to choose from:
;<pre><h6>
;     AGENT_POS_LEFT
;     AGENT_POS_RIGHT
;     AGENT_POS_UP   
;     AGENT_POS_DOWN 
;     AGENT_POS_REST 
;     AGENT_POS_GREET
;     AGENT_POS_SURPRISED
;</h6></pre>
;
;                          You should return the Agent to the Rest positon or the character
;                          will speak in its last position..
;
; #RETURN:      Nothing..
; --=====================================================================================--
MSAg_Gesture_Funct  PROC uses edi lpTHIS:DWORD, GCODE:DWORD
   LOCAL  IReqID  :DWORD
   LOCAL  TEMP    :DWORD
   LOCAL  TEMP2   :DWORD
   SetObject edi, MSAgent
     
     .if( [edi].hAgentChar )
        .if (GCODE == AGENT_POS_REST)
          lea eax, MSAg_szGestureRest
        .elseif (GCODE == AGENT_POS_UP)
          lea eax, MSAg_szGestureUp
        .elseif (GCODE == AGENT_POS_DOWN)
          lea eax, MSAg_szGestureDown
        .elseif (GCODE == AGENT_POS_LEFT)
          lea eax, MSAg_szGestureLeft
        .elseif (GCODE == AGENT_POS_RIGHT)
          lea eax, MSAg_szGestureRight
        .elseif (GCODE == AGENT_POS_GREET)
          lea eax, MSAg_szGestureGreet
        .elseif (GCODE == AGENT_POS_SURPRISED)
          lea eax, MSAg_szGestureSurprised
        .endif
        mov TEMP, eax
        
        invoke SysAllocString, TEMP
        mov TEMP2, eax
        coinvoke [edi].hAgentChar, IAgentCharacterEx, Play, TEMP2,  addr IReqID 
        invoke SysFreeString, TEMP2    

     .endif
     
   ReleaseObject edi
   ret
MSAg_Gesture_Funct  ENDP

; --=====================================================================================--
; #METHOD:      Speak (lpText)
;
; #DESCRIPTION: Speaks the ASCII text found in the lpText parameter.  Up to 2Kb is reserved
;               in any one speaking session. 4Kb for UNICODE -> 2Kb of ASCII. NOTE: The
;               character must be shown before speaking or nothing will happen..
;
; #PARAM:       lpText     This is the pointer to the text to be said..
;
; #RETURN:      Nothing..
; --=====================================================================================--
MSAg_Speak_Funct  PROC uses edi lpTHIS:DWORD, lpAsciiText:DWORD
   LOCAL TEMP    :DWORD
   LOCAL TEMP2   :DWORD
   LOCAL IReqID  :DWORD
   SetObject edi, MSAgent
        
     .if( [edi].hBuf )
                        
        ; Lock the buffer memory (4Kb)
        invoke GlobalLock, [edi].hBuf
        mov TEMP, eax
        
        Ascii2Unicode TEMP, lpAsciiText, 4096
        invoke SysAllocString, TEMP
        mov TEMP2, eax
        coinvoke [edi].hAgentChar, IAgentCharacterEx, Speak, TEMP2, NULL, addr IReqID 
        invoke SysFreeString, TEMP2    
        invoke GlobalUnlock, TEMP
     .endif

   ReleaseObject edi
   ret
MSAg_Speak_Funct  ENDP

; --=====================================================================================--
; #METHOD:      ReadClipboard(hWin)
;
; #DESCRIPTION: Reads the contents of the clipboard. NOTE: The
;               character must be shown before speaking or nothing will happen..
;
; #PARAM:       hWin    The handle of the owner window the clipboard should be opended to.
;
; #RETURN:      True if Read.  Flase if not..
; --=====================================================================================--
MSAg_ReadClipboard_Funct  PROC uses edi lpTHIS:DWORD, hWind:DWORD
   LOCAL TEMP    :DWORD
   LOCAL TEMP2   :DWORD
   LOCAL IReqID  :DWORD
   SetObject edi, MSAgent
        
   invoke OpenClipboard, hWind
   .if( eax )
        invoke Beep, NULL, NULL
        invoke GetClipboardData, CF_TEXT
        METHOD edi, MSAgent, Speak, eax
        invoke CloseClipboard
        invoke EmptyClipboard
        mov eax, TRUE
   .endif

   ReleaseObject edi
   ret
MSAg_ReadClipboard_Funct  ENDP

ENDIF
